(local { : Gtk : Gdk : WebKit2 : cairo } (require :lgi))
(local { : view } (require :fennel))
(local Command (require :command))

(var frames [])

(fn new-frame []
  (let [hpad 2
        vpad 2
        window (Gtk.Window {
                            :title "Dunlin"
                            :default_width 800
                            :default_height 720
                            :on_destroy Gtk.main_quit
                            })
        container (Gtk.Box {
                            :orientation Gtk.Orientation.VERTICAL
                            })
        commander (Gtk.Entry {
                              })
        progress-bar (Gtk.ProgressBar {
                                       :orientation Gtk.Orientation.HORIZONTAL
                                       :fraction 1.0
                                       :margin 0
                                       })
        contentwidget (Gtk.Box {
                                :orientation Gtk.Orientation.VERTICAL
                                })
        ]
    (tset commander :on_activate
          (fn [event]
            (let [result (Command.on-input event.text)]
              (print "result" (view result))
              (set commander.placeholder_text (or result.prompt ""))
              (set commander.text (or result.default "")))))

    (doto container
      (: :pack_start commander false false vpad)
      (: :pack_start progress-bar false false vpad)
      (: :pack_start contentwidget true true vpad))
    (window:add container)
    (window:show_all)
    (let [f
          {
           :window window
           :buffer nil
           :commander commander
           :content contentwidget
           :show-buffer (fn [self b]
                          (each [_ w (pairs (contentwidget:get_children))]
                            (w:hide))
                          (contentwidget:pack_start b.webview true true 0)
                          (b.webview:show))
           }]
      (table.insert frames f)
      f)))


{ :new new-frame :frames frames }
